/*

Miranda IM: the free IM client for Microsoft* Windows*

Copyright 2007 Artem Shpynov
Copyright 2000-2008 Miranda ICQ/IM project,

all portions of this codebase are copyrighted to the people
listed in contributors.txt.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef M_MODERNOPT_H__
#define M_MODERNOPT_H__ 1

/*
	260x210 - subsection
	368x210 - section
*/

#define MS_MODERNOPT_SHOW			"ModernOpt/Show"

#define ME_MODERNOPT_INITIALIZE		"ModernOpt/Initialize"

#define MODEROPT_FLG_UNICODE		0x01
#ifdef UNICODE
	#define MODEROPT_FLG_TCHAR		MODEROPT_FLG_UNICODE
#else
	#define MODEROPT_FLG_TCHAR		0
#endif

typedef enum {
	MODERNOPT_TYPE_SECTIONPAGE,
	MODERNOPT_TYPE_SUBSECTIONPAGE,
	MODERNOPT_TYPE_IGNOREOBJECT,
	MODERNOPT_TYPE_COUNT
};

typedef enum {
	MODERNOPT_PAGE_HOME,
	MODERNOPT_PAGE_ACCOUNTS,
	MODERNOPT_PAGE_SKINS,
	MODERNOPT_PAGE_CLIST,
	MODERNOPT_PAGE_MSGS,
	MODERNOPT_PAGE_IGNORE,
	MODERNOPT_PAGE_STATUS,
	MODERNOPT_PAGE_ADVANCED,
	MODERNOPT_PAGE_MODULES,
	MODERNOPT_PAGE_COUNT
};

#define MODERNOPT_CTRL_LAST		0

typedef struct {
	int					cbSize;
	DWORD				dwFlags;
	int					iType;
	int					iSection;

	HICON				hIcon;
	union {
		TCHAR			*lptzSubsection;
		char			*lpzSubsection;
		WCHAR			*lpwzSubsection;
	};

	HINSTANCE			hInstance;
	char				*lpzTemplate;
	DLGPROC				pfnDlgProc;
	int					*iBoldControls;

	char				*lpszClassicGroup;
	char				*lpszClassicPage;
	char				*lpszClassicTab;
	char				*lpszHelpUrl;

	union {
		struct {
			HICON		hIcon;
			union {
				TCHAR	*lptzName;
				char	*lpzName;
				WCHAR	*lpwzName;
			};

			char		*lpzModule;
			char		*lpzSetting;
			DWORD		dwBit;
		} objIgnore;
	};
} MODERNOPTOBJECT;

#define MS_MODERNOPT_ADDOBJECT		"ModernOpt/AddObject"

#define MS_MODERNOPT_SELECTPAGE		"ModernOpt/SelectPage"

#define ME_MODERNINGORE_RELOAD		"ModernOpt/Ignore/Reload"

#endif // M_MODERNOPT_H__
